main()
{
	//maps\mp\mp_illusion_fx::main();
	//maps\createart\mp_illusion_art::main();
	maps\mp\_load::main();	
	
	maps\mp\_compass::setupMiniMap("compass_map_mp_illusion");

	//setExpFog(500, 2200, 0.81, 0.75, 0.63, 0);
	//VisionSetNaked( "mp_illusion" );
	ambientPlay("ambient_illusion_ext");

	game["allies"] = "sas";
	game["axis"] = "opfor";
	game["attackers"] = "axis";
	game["defenders"] = "allies";
	game["allies_soldiertype"] = "woodland";
	game["axis_soldiertype"] = "woodland";

	setdvar("r_specularcolorscale", "1" );
	setdvar("r_glowbloomintensity0",".25");
	setdvar("r_glowbloomintensity1",".25");
	setdvar("r_glowskybleedintensity0",".3");
	setdvar("compassmaxrange","1800");

	//rotatinghall code
	rotatinghall = getentarray("rotatinghall","targetname");
	for(i=0;i<rotatinghall.size;i++)
	{
		rotatinghall[i] thread rotate_hall();
	}

	//fakewall code
	fakewall = getentarray("fakewall","targetname");
	for(i=0;i<fakewall.size;i++)
	{
		fakewall[i] notSolid();
	}

	//wacky_color code
	wacky_color = getent("wacky_color","targetname");
	wacky_color thread start_wacky_colors();

	//fakewallrandom code
	fakewallrandomentity = getent("fakewallrandomentity","targetname");
	fakewallrandomentity thread randomize_fake_wall();

	//teleport code
	trig_teleport = getentarray("trig_teleport","targetname");
	for(i=0;i<trig_teleport.size;i++)
	{
		trig_teleport[i].destination = getent(trig_teleport[i].target, "targetname");
		trig_teleport[i] thread teleport();
		trig_teleport[i] thread teleport_fx_begin();
	}

}

//fakewallrandom code
randomize_fake_wall()
{
	timeinterval=3;
	fakewallrandom = getentarray("fakewallrandom","targetname");
	while (true)
	for(i=0;i<fakewallrandom.size;i++)
	{
		fakewallrandom[i] notSolid();
		wait(timeinterval);
		fakewallrandom[i] Solid();
	}
}

//rotatinghall code
rotate_hall()
{
	self notSolid();
	while (true)
	{	
		self rotatepitch(360, 5);
		self waittill("rotatedone");
	}
}

//teleport code
teleport_fx_begin()
{
	level._effect["teleport_lights"] = loadfx("misc/teleport_lights");
	maps\mp\_fx::loopfx("teleport_lights", (self.destination.origin), 0.5);	
}

teleport()
{
	while (1)
	{
		self waittill("trigger", user);
		user setorigin(self.destination.origin);
		wait(0.1);
		user playlocalsound("teleport");
		wait(0.1);
	}
}

//wacky_color code
start_wacky_colors()
{
	maxcolor=256;
	halfwaydistance=512;
	timeinterval=0.05;
	while (1)
	{
		for(r=0;r<maxcolor;r++)
		{
			setExpFog(0, halfwaydistance, 1-r/maxcolor, r/maxcolor, 0, timeinterval);
			wait(timeinterval);
		}
		for(g=0;g<maxcolor;g++)
		{
			setExpFog(0, halfwaydistance, 0, 1-g/maxcolor, g/maxcolor, timeinterval);
			wait(timeinterval);
		}
		for(b=0;b<maxcolor;b++)
		{
			setExpFog(0, halfwaydistance, b/maxcolor, 0, 1-b/maxcolor, timeinterval);
			wait(timeinterval);
		}
	}
}